#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <err.h>
#include "execinfo.h"

#ifndef __arraycount
#define __arraycount(a) (sizeof(a) / sizeof(a[0]))
#endif

static void
myfunc3(int ncalls)
{
	int j, nptrs;
	void *buffer[ncalls + 10];
	char **strings;

	nptrs = backtrace(buffer, __arraycount(buffer));
	printf("backtrace() returned %d addresses\n", nptrs);

	/*
	 * The call backtrace_symbols_fd(buffer, nptrs, STDOUT_FILENO) would
	 * produce similar output to the following:
	 */
	strings = backtrace_symbols(buffer, nptrs);
	if (strings == NULL)
		err(1, "backtrace_symbols");
	for (j = 0; j < nptrs; j++)
		printf("%s\n", strings[j]);

	free(strings);
}

static void
myfunc2(int ncalls)
{
	myfunc3(ncalls);
}

static void
myfunc1(int origcalls, int ncalls)
{
	if (ncalls > 1)
		myfunc1(origcalls, ncalls - 1);
	else
		myfunc2(origcalls);
}

static void
myfunc(int ncalls)
{
	myfunc1(ncalls, ncalls);
}

int
main(int argc, char *argv[])
{
	if (argc != 2) {
		fprintf(stderr, "%s num-calls\n", argv[0]);
		exit(EXIT_FAILURE);
	}
	myfunc(atoi(argv[1]));
	exit(EXIT_SUCCESS);
}
